//
//  BSViewController.m
//  MicroLifeDeviceSDK-Demo
//
//  Created by willy.wu on 2022/4/26.
//  Copyright © 2022 WiFi@MBP. All rights reserved.
//

#import "BSViewController.h"

@interface BSViewController ()

@end

@implementation BSViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    [self viewHidden:0];
    [self connectBloodSugar];
    [self connectBS];
    [self.sdk device:@[self.bloodSugar,self.bs]];
    kWeakSelf(self)
    [self.sdk getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    }];
    [self.sdk getScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^() {
        [weakself addLogWhitText:@"Cancel Scan"];
        [weakself viewHidden:0];
        [weakself.sdk startScan];
    }];
    [self.sdk getConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"Cancel All Devices Connection"];
        [weakself viewHidden:0];
        [weakself.sdk startScan];
    }];
}

- (void)viewDidLayoutSubviews {
    self.butView.contentSize = CGSizeMake(self.butView.frame.size.width, self.butView.frame.size.height*5);
    self.bsView.contentSize = CGSizeMake(self.bsView.frame.size.width, self.bsView.frame.size.height*5);
}

- (void)viewHidden:(NSInteger)ss {
    switch (ss) {
        case 1:
            self.bsView.hidden = YES;
            self.butView.hidden = NO;
            break;
        case 2:
            self.bsView.hidden = NO;
            self.butView.hidden = YES;
            break;
        default:
            self.bsView.hidden = self.butView.hidden = YES;
            break;
    }
}

#pragma mark - IBAction
- (IBAction)comAction:(UIButton *)sender {
    NSString *log = sender.titleLabel.text;
    [self addLogWhitText:log];
    switch (sender.tag) {
        case 100:
            [self.bloodSugar readDeviceName];
            break;
        case 101:
            [self.bloodSugar readFWVersion];
            break;
        case 102:
            [self.bloodSugar getBLEStatus];
            break;
        case 103:
            [self.bloodSugar readLastData];
            break;
        case 104:
            if (self.value2Text.text.integerValue > 0) {
                [self.bloodSugar readData:self.value2Text.text.integerValue];
            }
            break;
        case 105:
            [self.bloodSugar readDataLength];
            break;
        case 106:
            [self.bloodSugar disconnect];
            break;
        case 107:
            [self.bloodSugar readDateTime];
            break;
        case 108:
            [self.bloodSugar writeDeviceName:self.value1Text.text];
            break;
        case 109:
            [self.bloodSugar getMeterDataTransmissionStatus];
            break;
        case 110:
            [self.bloodSugar getCommunicationMode];
            break;
        case 111:
            [self.bloodSugar setBLEParingMode];
            break;
        case 112:
            [self.bloodSugar setMeterAuthorization];
            break;
        case 113:
            [self.bloodSugar setParingRequest];
            break;
        case 114:
            [self.bloodSugar setParingTimeOut];
            break;
        case 200:
            [self.bs QueryMachineFunction];
            break;
        case 201:
            [self.bs QueryUricAcidDatas:PARAMAll SN1:@(self.value1Text.text.integerValue) SN2:@(self.value2Text.text.integerValue)];
            break;
        case 202:
            [self.bs QueryCholesterolDatas:PARAMAll SN1:@(self.value1Text.text.integerValue) SN2:@(self.value2Text.text.integerValue)];
            break;
        case 203:
            [self.bs QueryBloodKetoneDatas:PARAMAll SN1:@(self.value1Text.text.integerValue) SN2:@(self.value2Text.text.integerValue)];
            break;
        case 204:
            [self.bs QueryGKIDatas:PARAMAll SN1:@(self.value1Text.text.integerValue) SN2:@(self.value2Text.text.integerValue)];
            break;
        case 205:
            [self.bs QueryLactateDatas:PARAMAll SN1:@(self.value1Text.text.integerValue) SN2:@(self.value2Text.text.integerValue)];
            break;
        case 206:
            [self.bs QueryBloodGlucoseDatas:PARAMAll SN1:@(self.value1Text.text.integerValue) SN2:@(self.value2Text.text.integerValue)];
            break;
        case 207:
            [self.bs QueryHemeDatas:PARAMAll SN1:@(self.value1Text.text.integerValue) SN2:@(self.value2Text.text.integerValue)];
            break;
        case 208:
            [self.bs DownloadBloodGlucoseData:PARAMAll SN1:@(self.value1Text.text.integerValue) SN2:@(self.value2Text.text.integerValue)];
            break;
        case 209:
            [self.bs DownloadUricAcidData:PARAMAll SN1:@(self.value1Text.text.integerValue) SN2:@(self.value2Text.text.integerValue)];
            break;
        case 210:
            [self.bs DownloadCholesterolData:PARAMAll SN1:@(self.value1Text.text.integerValue) SN2:@(self.value2Text.text.integerValue)];
            break;
        case 211:
            [self.bs DownloadBloodKetoneData:PARAMAll SN1:@(self.value1Text.text.integerValue) SN2:@(self.value2Text.text.integerValue)];
            break;
        case 212:
            [self.bs DownloadGKIData:PARAMAll SN1:@(self.value1Text.text.integerValue) SN2:@(self.value2Text.text.integerValue)];
            break;
        case 213:
            [self.bs DownloadLactateData:PARAMAll SN1:@(self.value1Text.text.integerValue) SN2:@(self.value2Text.text.integerValue)];
            break;
        case 214:
            [self.bs DownloadHemeData:PARAMAll SN1:@(self.value1Text.text.integerValue) SN2:@(self.value2Text.text.integerValue)];
            break;
        default:
            break;
    }
}


- (void)connectBloodSugar {
    kWeakSelf(self)
    self.dataLength = 1;
    self.bloodSugar = [MicroLifeBloodSugar shareWhithAuthorizationkey:SDKkey_BS];
    [self.bloodSugar deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.bloodSugar];
        [weakself addLogWhitText:log];
        [weakself viewHidden:1];
    }];
    [self.bloodSugar getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.bloodSugar CMD:CMD Model:model Error:error];
        switch (CMD) {
            case CMDBloodSugarReadDataLength:
                [weakself addValue1:nil Value2:((MicroLifeBloodSugarMeasureData *)model).recordCounts.stringValue];
                break;
            case CMDBloodSugarReadDeviceName:
                [weakself addValue1:((MicroLifeDeviceInfo *)model).BTModuleName Value2:nil];
                break;
            case CMDBloodSugarReadFWVersion:
            case CMDBloodSugarBLEStatus:
            case CMDBloodSugarReadData:
            case CMDBloodSugarReadNewData:
            case CMDBloodSugarReadHistorysData:
            case CMDBloodSugarReadLastData:
            case CMDBloodSugarDisconnect:
            case CMDBloodSugarReadDateTime:
                break;
            default:
                break;
        }
    }];
}

- (void)connectBS {
    kWeakSelf(self)
    self.bs = [MicroLifeBS shareWhithAuthorizationkey:SDKkey_BS];
    [self.bs deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.bs];
        [weakself addLogWhitText:log];
        [weakself viewHidden:2];
    }];
    [self.bs getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.bs CMD:CMD Model:model Error:error];
        switch (CMD) {
            case CMDBSQueryMachineFunction:
                break;
            case CMDBSQueryBloodGlucoseDatas:
            case CMDBSQueryUricAcidDatas:
            case CMDBSQueryCholesterolDatas:
            case CMDBSQueryBloodKetoneDatas:
            case CMDBSQueryGKIDatas:
            case CMDBSQueryLactateDatas:
            case CMDBSQueryHemeDatas:
                [weakself addValue1:((MicroLifeDeviceInfo *)model).maxMemory.stringValue Value2:nil];
                break;
            case CMDBSDownloadBloodGlucoseData:
            case CMDBSDownloadUricAcidData:
            case CMDBSDownloadCholesterolData:
            case CMDBSDownloadBloodKetoneData:
            case CMDBSDownloadGKIData:
            case CMDBSDownloadLactateData:
            case CMDBSDownloadHemeData:
                break;
            default:
                break;
        }
    }];
}

- (void)addValue1:(id)value1 Value2:(id)value2 {
    self.value1Text.text = value1?:@"";
    self.value2Text.text = value2?:@"";
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
