//
//  MenuInfo.m
//  MicroLifeDeviceSDK-Demo
//
//  Created by 吳憲有 on 2022/12/8.
//  Copyright © 2022 WiFi@MBP. All rights reserved.
//

#import "MenuInfo.h"

@implementation MenuInfo

- (instancetype)init {
    self = [super init];
    if (self) {
        [self removalInfo];
    }
    return self;
}

- (void)removalInfo {
    self.backgroundColor = [IdeabusToolBox ib_RainbowColor:ColorBright];
    self.textColor = [IdeabusToolBox ib_ComplementaryColor:self.backgroundColor Alpha:1.0];
    self.device = nil;
    self.name = nil;
    self.UUID = nil;
    self.RSSI = nil;
}

- (void)addDevice:(MicroLifeDevice *)device {
    self.device = device;
    self.name = device.name;
    self.UUID = device.UUID;
    self.RSSI = device.RSSI;
}

+ (NSMutableArray *)menus {
    MenuInfo *a = [MenuInfo new];
    a.title = @"Scan Device";
    a.deviceType = 100;
    MenuInfo *b = [MenuInfo new];
    b.title = @"Cloud API";
    b.deviceType = 101;
    MenuInfo *c = [MenuInfo new];
    c.title = @"SEND SUPPORT EMAIL";
    c.deviceType = 102;
    MenuInfo *d = [MenuInfo new];
    d.title = @"3G BP";
    d.deviceType = DeviceType3GBP;
    MenuInfo *e = [MenuInfo new];
    e.title = @"4G BP";
    e.deviceType = DeviceType4GBP;
    MenuInfo *f = [MenuInfo new];
    f.title = @"Weight";
    f.deviceType = DeviceTypeWeight;
    MenuInfo *g = [MenuInfo new];
    g.title = @"Temperature";
    g.deviceType = DeviceTypeTemperature;
    MenuInfo *h = [MenuInfo new];
    h.title = @"Oxygen";
    h.deviceType = DeviceTypeOxygen;
    MenuInfo *i = [MenuInfo new];
    i.title = @"WatchBP Home";
    i.deviceType = DeviceTypeWatchBPHome;
    MenuInfo *j = [MenuInfo new];
    j.title = @"WatchBP O3";
    j.deviceType = DeviceTypeWatchBPO3;
    MenuInfo *k = [MenuInfo new];
    k.title = @"WatchBP Office";
    k.deviceType = DeviceTypeWatchBPOffice;
    MenuInfo *l = [MenuInfo new];
    l.title = @"Electrocardiography";
    l.deviceType = DeviceTypeECG;
    MenuInfo *m = [MenuInfo new];
    m.title = @"WatchBP M1";
    m.deviceType = DeviceTypeWatchBPM1;
    MenuInfo *n = [MenuInfo new];
    n.title = @"Blood Sugar";
    n.deviceType = DeviceTypeBloodSugar;
    MenuInfo *o = [MenuInfo new];
    o.title = @"Peakflow Meter";
    o.deviceType = DeviceTypePFM;
    NSMutableArray *menus = [NSMutableArray arrayWithObjects:a, b, c, d, e, f, g, h, i, j, k, m, n, o, l, nil];
    return menus;
}

@end
