 //
//  OFAViewController.m
//  MicroLifeDeviceSDK-Dome
//
//  Created by WiFi@ on 2018/6/5.
//  Copyright © 2018年 WiFi@MBP. All rights reserved.
//

#import "OFAViewController.h"

@implementation OFAViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    [self connect3GBP];
    [self connect4GBP];
    [self connectTemperature];
    [self connectOxygen];
    [self connectWeight];
    [self connectBloodSugar];
    [self connectWatchBPOfficeLTC];
    [self connectWatchBPOffice];
    [self connectWatchBPHome];
    [self connectPFM];
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma device
- (void)connect3GBP {
    kWeakSelf(self)
    self.bp3g = [MicroLife3GBP shareWhithAuthorizationkey:SDKkey_BPM];
    [self.bp3g getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"bp3g DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"bp3g ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"bp3g Cancel Scan"];
        [weakself.bp3g startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"bp3g Cancel All Devices Connection"];
        [weakself.bp3g startScan];
    }];
    [self.bp3g deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.bp3g];
        [weakself addLogWhitText:log];
    }];
    [self.bp3g getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.bp3g CMD:CMD Model:model Error:error];
        switch (CMD) {
            case CMD3GReadUserAndVersionData:
                [weakself.bp3g readHistorys];
                break;
            case CMD3GReadHistorys:
                [weakself.bp3g disconnect];
                break;
            default:
                break;
        }
    }];
}

- (void)connect4GBP {
    kWeakSelf(self)
    self.bp4g = [MicroLife4GBP shareWhithAuthorizationkey:SDKkey_BPM];
    [self.bp4g addDeviceModel:@[@"6024N"]];
    [self.bp4g getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"bp4g DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"bp4g ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"bp4g Cancel Scan"];
        [weakself.bp4g startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"bp4g Cancel All Devices Connection"];
        [weakself.bp4g startScan];
    }];
    [self.bp4g deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.bp4g];
        [weakself addLogWhitText:log];
    }];
    [self.bp4g getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.bp4g CMD:CMD Model:model Error:error];
        switch (CMD) {
            case CMD4GReadUserAndVersionData:
                [weakself.bp4g readHistorys];
                break;
            case CMD4GReadHistorys:
                [weakself.bp4g disconnect];
                break;
            default:
                break;
        }
    }];
}

- (void)connectTemperature {
    kWeakSelf(self)
    self.temperature = [MicroLifeTemperature shareWhithAuthorizationkey:SDKkey_BT];
    //[self.temperature addDeviceModel:@[@"FR1DQ1-B"]];
    [self.temperature getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"temperature DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"temperature ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"temperature Cancel Scan"];
        [weakself.temperature startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"temperature Cancel All Devices Connection"];
        [weakself.temperature startScan];
    }];
    [self.temperature deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.temperature];
        [weakself addLogWhitText:log];
    }];
    [self.temperature getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.temperature CMD:CMD Model:model Error:error];
    }];
}

- (void)connectOxygen {
    kWeakSelf(self)
    self.oxygen = [MicroLifeOxygen shareWhithAuthorizationkey:SDKkey_SPO2];
    [self.oxygen getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"oxygen DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"oxygen ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"oxygen Cancel Scan"];
        [weakself.oxygen startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"oxygen Cancel All Devices Connection"];
        [weakself.oxygen startScan];
    }];
    [self.oxygen deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.oxygen];
        [weakself addLogWhitText:log];
    }];
    [self.oxygen getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.oxygen CMD:CMD Model:model Error:error];
    }];
}

- (void)connectWeight {
    kWeakSelf(self)
    self.weight = [MicroLifeWeight shareWhithAuthorizationkey:SDKkey_WEI];
    [self.weight getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"weight DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"weight ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"weight Cancel Scan"];
        [weakself.weight startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"weight Cancel All Devices Connection"];
        [weakself.weight startScan];
    }];
    [self.weight deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.weight];
        [weakself addLogWhitText:log];
    }];
    [self.weight getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.weight CMD:CMD Model:model Error:error];
        switch (CMD) {
            case CMDWeightWakeUpScale:
                [weakself addLogWhitText:@"WakeUp Scale"];
                [weakself.weight writeUserData:weakself.currUser.weightUserID Age:weakself.currUser.age.integerValue Gender:weakself.currUser.gender Height:weakself.currUser.height.integerValue RoleType:weakself.currUser.roleType Weight:weakself.currUser.weight.floatValue Resistance:weakself.currUser.resistance.integerValue];
                [weakself.weight readHistorys];
                break;
            case CMDWeightSleepScale:
                [weakself addLogWhitText:@"Sleep Scale"];
                [weakself.weight disconnect];
                break;
            case CMDWeightMeasurementResult:
                [weakself addLogWhitText:@"Measurement Result"];
                weakself.currUser.resistance = ((MicroLifeBodyFat *)model).resistance;
                [weakself saveNSUserDefaults:weakself.currUser.resistance Key:@"resistance"];
                break;
            case CMDWeightReadHistorys:
                [weakself addLogWhitText:@"Read Historys"];
                weakself.currUser.resistance = ((MicroLifeBodyFat *)model).resistance;
                [weakself saveNSUserDefaults:weakself.currUser.resistance Key:@"resistance"];
                break;
            case CMDWeightUpdateUserInfo:
                [weakself addLogWhitText:@"Update UserInfo"];
                break;
            case CMDWeightClearAllUserInfo:
                [weakself addLogWhitText:@"Clear All UserInfo"];
                break;
            case CMDWeightNoMoreOfflineData:
                [weakself addLogWhitText:@"No More OfflineData"];
                break;
            case CMDWeightLowPower:
                [weakself addLogWhitText:@"Low Power"];
                break;
            case CMDWeightSyncSystemClock:
                [weakself addLogWhitText:@"Sync System Clock"];
                break;
            default:
                break;
        }
    }];
}

- (void)connectBloodSugar {
    kWeakSelf(self)
    self.dataLength = 1;
    self.bloodSugar = [MicroLifeBloodSugar shareWhithAuthorizationkey:SDKkey_BS];
    [self.bloodSugar getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"bloodSugar DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"bloodSugar ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"bloodSugar Cancel Scan"];
        [weakself.bloodSugar startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"bloodSugar Cancel All Devices Connection"];
        [weakself.bloodSugar startScan];
    }];
    [self.bloodSugar deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.bloodSugar];
        [weakself addLogWhitText:log];
    }];
    [self.bloodSugar getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.bloodSugar CMD:CMD Model:model Error:error];
    }];
}

- (void)connectWatchBPOffice {
    kWeakSelf(self)
    self.watchBPOffice = [MicroLifeWatchBPOffice shareWhithAuthorizationkey:SDKkey_WBP];
    [self.watchBPOffice getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"watchBPOffice DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"watchBPOffice ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"watchBPOffice Cancel Scan"];
        [weakself.watchBPOffice startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"watchBPOffice Cancel All Devices Connection"];
        [weakself.watchBPOffice startScan];
    }];
    [self.watchBPOffice deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.watchBPOffice];
        [weakself addLogWhitText:log];
    }];
    [self.watchBPOffice getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.watchBPOffice CMD:CMD Model:model Error:error];
        switch (CMD) {
            case CMDWatchBPOfficeReadHistorys:
                [weakself.watchBPOffice disconnect];
                break;
            case CMDWatchBPOfficeReadUserAndVersionData:
                [weakself.watchBPOffice readAllHistorys];
                break;
            default:
                break;
        }
    }];
}

- (void)connectWatchBPOfficeLTC {
    kWeakSelf(self)
    self.watchBPM1 = [MicroLifeWatchBPM1 shareWhithAuthorizationkey:SDKkey_WBP];
    [self.watchBPM1 getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"watchBPM1 DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"watchBPM1 ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"watchBPM1 Cancel Scan"];
        [weakself.watchBPM1 startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"watchBPM1 Cancel All Devices Connection"];
        [weakself.watchBPM1 startScan];
    }];
    [self.watchBPM1 deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.watchBPM1];
        [weakself addLogWhitText:log];
    }];
    [self.watchBPM1 getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.watchBPM1 CMD:CMD Model:model Error:error];
        switch (CMD) {
            case CMDWatchBPM1ReadHistorys:
                [weakself.watchBPM1 disconnect];
                break;
            case CMDWatchBPM1ReadUserAndVersionData:
                [weakself.watchBPM1 readAllHistorys];
                break;
            default:
                break;
        }
    }];
}

- (void)connectWatchBPHome {
    kWeakSelf(self)
    self.watchBPHome = [MicroLifeWatchBPHome shareWhithAuthorizationkey:SDKkey_WBP];
    [self.watchBPHome getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"watchBPHome DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"watchBPHome ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"watchBPHome Cancel Scan"];
        [weakself.watchBPHome startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"watchBPHome Cancel All Devices Connection"];
        [weakself.watchBPHome startScan];
    }];
    [self.watchBPHome deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.watchBPHome];
        [weakself addLogWhitText:log];
    }];
    [self.watchBPHome getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.weight CMD:CMD Model:model Error:error];
        switch (CMD) {
            case CMDWatchBPHomeReadUsualModeHistoryData:
                [weakself.watchBPHome disconnect];
                break;
            case CMDWatchBPHomeReadUserAndVersionData:
                [weakself.watchBPHome readUsualModeHistoryData];
                break;
            default:
                break;
        }
    }];
}
- (void)connectWatchBPO3 {
    kWeakSelf(self)
    self.watchBPO3 = [MicroLifeWatchBPO3 shareWhithAuthorizationkey:SDKkey_WBP];
    [self.watchBPO3 getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"watchBPO3 DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"watchBPO3 ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"watchBPO3 Cancel Scan"];
        [weakself.watchBPO3 startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"watchBPO3 Cancel All Devices Connection"];
        [weakself.watchBPO3 startScan];
    }];
    [self.watchBPO3 deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.watchBPO3];
        [weakself addLogWhitText:log];
    }];
    [self.watchBPO3 getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.watchBPO3 CMD:CMD Model:model Error:error];
        switch (CMD) {
            case CMDWatchBPO3ReadHistorys:
                [weakself.watchBPO3 disconnect];
                break;
            case CMDWatchBPO3ReadUserAndVersionData:
                [weakself.watchBPO3 readAllHistorys];
                break;
            default:
                break;
        }
    }];
}

- (void)connectPFM {
    kWeakSelf(self)
    self.peakFlowMeter = [MicroLifePFM shareWhithAuthorizationkey:SDKkey_PF];
    [self.peakFlowMeter getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"peakFlowMeter DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"peakFlowMeter ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"peakFlowMeter Cancel Scan"];
        [weakself.peakFlowMeter startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"bloodSugar Cancel All Devices Connection"];
        [weakself.peakFlowMeter startScan];
    }];
    [self.peakFlowMeter deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.peakFlowMeter];
        [weakself addLogWhitText:log];
    }];
    [self.peakFlowMeter getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.peakFlowMeter CMD:CMD Model:model Error:error];
        switch (CMD) {
            case CMDPFMReadHistorys:
                [weakself.peakFlowMeter disconnect];
                break;
            case CMDPFMReadLastData:
                [weakself.peakFlowMeter readHistorys];
                break;
            case CMDPFMReadUserAndVersionData:
                [weakself.peakFlowMeter checkMode];
                break;
            case CMDPFMReadBestValue:
                [weakself.peakFlowMeter readLastData];
                break;
            case CMDPFMCheckMode:
                [weakself.peakFlowMeter readBestValue];
                break;
            default:
                break;
        }
    }];
}
@end
