//
//  LogManager.h
//  MicroLifeDeviceSDK-Dev
//
//  Created by willy.wu on 2019/12/19.
//  Copyright © 2019 WiFi@MBP. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface LogManager : NSObject
//Print Log
@property (nonatomic,assign) BOOL showLog;
// Current screen controller
@property (nonatomic,strong) id rootVC;
/**
 *  Get singleton instance
 *  @return Singleton instance
 */
+ (instancetype)sharedInstance;

#pragma mark - Method

/// show Log
/// @param showLog showLog
- (void)showLog:(BOOL)showLog;


/// set Password
/// @param password password
- (void)setPW:(NSString *)password;

/// add Log File
/// @param url url
- (void)addLogFile:(NSURL *)url;

/// set Log Max Save Day[7Day]
/// @param logMaxSaveDay logMaxSaveDay
- (void)setMaxSaveDay:(NSInteger)logMaxSaveDay;

/**
 *  Write log
 *
 *  @param module Module
 *  @param format Log information, dynamic parameters
 */
- (void)logInfo:(NSString *)module
         logStr:(NSString *)format, ...;

/**
 *  Empty expired logs
 */
- (void)clearExpiredLog;

/// Send log
/// @param info <#info description#>
/// @param app_Name <#app_Name description#>
/// @param app_Version <#app_Version description#>
- (void)sendSupportMailWithInfo:(NSString*)info
                        AppName:(NSString *)app_Name
                     AppVersion:(NSString *)app_Version;

/// Send log
/// @param info <#info description#>
/// @param app_Name <#app_Name description#>
/// @param app_Version <#app_Version description#>
/// @param emails <#emails description#>
- (void)sendSupportMailWithInfo:(NSString*)info
                        AppName:(NSString *)app_Name
                     AppVersion:(NSString *)app_Version
                         Emails:(NSArray *)emails;

/// Get compressed log file
- (NSString *)getLogZip;

@end

NS_ASSUME_NONNULL_END
