//
//  MicroLifeBloodSugar.h
//  MicroLifeDeviceSDK
//
//  Created by willy.wu on 2022/2/18.
//

#import <MicroLifeDeviceSDK/MicroLifeDeviceSDK.h>

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSInteger , CMDBloodSugar) {
    CMDBloodSugarReadDeviceName = 0x01,
    CMDBloodSugarReadFWVersion = 0x02,
    CMDBloodSugarBLEStatus = 0x20,
    CMDBloodSugarReadData = 0x35,
    CMDBloodSugarReadNewData = 0x3500,
    CMDBloodSugarReadHistorysData = 0x3550,
    CMDBloodSugarReadLastData = 0x3501,
    CMDBloodSugarReadDataLength = 0x3502,
    CMDBloodSugarDisconnect = 0x36,
    CMDBloodSugarReadDateTime = 0x45,
    CMDBloodSugarUploadMeterData = 0x50,
    CMDBloodSugarWriteDeviceName = 0x51,
    CMDBloodSugarMeterDataTransmissionStatus = 0x52,
    CMDBloodSugarCommunicationMode = 0x53,
    CMDBloodSugarBLEParingMode = 0x60,
    CMDBloodSugarMeterAuthorization = 0x61,
    CMDBloodSugarParingRequest = 0x70,
    CMDBloodSugarParingTimeOut = 0x71
};

@interface MicroLifeBloodSugar : MicroLifeDevice

#pragma mark - CMD

/// read Device Name
- (void)readDeviceName;

/// read FW Version
- (void)readFWVersion;

/// get BLEStatus
- (void)getBLEStatus;

/// read Last Data
- (void)readLastData;

/// read Data form counts
/// @param counts counts
- (void)readData:(NSInteger)counts;

/// read Data Length
- (void)readDataLength;

/// upload Meter Data
- (void)uploadMeterData;

/// disconnect
- (void)disconnect;

/// read DateTime
- (void)readDateTime;

/// write Device Name
/// @param name name
- (void)writeDeviceName:(NSString *)name;

/// get Meter Data Transmission Status
- (void)getMeterDataTransmissionStatus;

/// get Communication Mode
- (void)getCommunicationMode;

/// set BLE ParingMode
- (void)setBLEParingMode;

/// set Meter Authorization
- (void)setMeterAuthorization;

/// set Paring Request
- (void)setParingRequest;

/// set Paring TimeOut
- (void)setParingTimeOut;
@end

NS_ASSUME_NONNULL_END
