//
//  MicroLifeECGDRecord.h
//  MicroLifeDeviceSDK
//
//  Created by willy.wu on 2022/7/19.
//

#import <MicroLifeDeviceSDK/MicroLifeDeviceSDK.h>

NS_ASSUME_NONNULL_BEGIN

@interface MicroLifeECGDRecord : MicroLifeDataModel

/**
 History Measurement times:
 The history measurement times store in memory.
 */
@property (nonatomic, strong) NSNumber *historyMeasuremeNumber;

/**
 UserNumber:User1=1,User2=2,Guest=3
 */
@property (nonatomic, strong) NSNumber *userNumber;

/**
 MAMversion:0x00=MAMweight,0x01=MAMlight,0Xff=NoMAMfunction.
 The MAM result is calculated by simple arithmetic mean (MAM light) or weighted mean (MAM weight).
 */
@property (nonatomic, strong) NSNumber *MAMversion;

/**
 All blood pressure menasurement data
 */
@property (nonatomic, strong) NSMutableArray *MData;

@end

NS_ASSUME_NONNULL_END
