//
//  MicroLifeECGRawData.h
//  MicroLifeDeviceSDK
//
//  Created by willy.wu on 2022/7/25.
//

#import <MicroLifeDeviceSDK/MicroLifeDeviceSDK.h>

NS_ASSUME_NONNULL_BEGIN

@interface MicroLifeECGRawData : MicroLifeDataModel

/// ECGs
@property (nonatomic, strong) NSMutableArray *ECGs;

/// RTOR
@property (nonatomic, strong) NSNumber *RTOR;

/// BPM
@property (nonatomic, strong) NSNumber *BPM;

/// EINT
@property (nonatomic, strong) NSNumber *EINT;

/// EOVF
@property (nonatomic, strong) NSNumber *EOVF;

/// DCLOFFINT
@property (nonatomic, strong) NSNumber *DCLOFFINT;

/// LONINT
@property (nonatomic, strong) NSNumber *LONINT;

/// RRINT
@property (nonatomic, strong) NSNumber *RRINT;

/// SAMP
@property (nonatomic, strong) NSNumber *SAMP;

/// PLLINT
@property (nonatomic, strong) NSNumber *PLLINT;

/// LDOFF_PH
@property (nonatomic, strong) NSNumber *LDOFF_PH;

/// LDOFF_PL
@property (nonatomic, strong) NSNumber *LDOFF_PL;

/// LDOFF_NH
@property (nonatomic, strong) NSNumber *LDOFF_NH;

/// LDOFF_NL
@property (nonatomic, strong) NSNumber *LDOFF_NL;

/// LDOFF
@property (nonatomic, strong) NSNumber *LDOFF;

- (void)analysis:(DeviceType)deviceType CMD:(NSInteger)CMD Data:(id)value UUID:(NSString *)UUID Mac:(NSData *)mac ECGCalGain:(NSNumber *)ECGCalGain;

@end

NS_ASSUME_NONNULL_END
