//
//  MicroLifeECGSampleData.h
//  MicroLifeDeviceSDK
//
//  Created by willy.wu on 2022/7/25.
//

#import <MicroLifeDeviceSDK/MicroLifeDeviceSDK.h>

NS_ASSUME_NONNULL_BEGIN

@interface MicroLifeECGSampleData : MicroLifeDataModel

/// ECG (Spec voltage (mV))
@property (nonatomic, strong) NSNumber *ECG;

/// ECG RAW Data 
@property (nonatomic, strong) NSNumber *ECGr;

/// ECG (Calibration voltage (mV))
@property (nonatomic, strong) NSNumber *ECGc;

/// ETAG
@property (nonatomic, strong) NSNumber *ETAG;

/// PTAG
@property (nonatomic, strong) NSNumber *PTAG;

- (void)analysis:(DeviceType)deviceType CMD:(NSInteger)CMD Data:(id)value UUID:(NSString *)UUID Mac:(NSData *)mac ECGCalGain:(NSNumber *)ECGCalGain;
@end

NS_ASSUME_NONNULL_END
