//
//  MicroLifeECGSettingValues.h
//  MicroLifeDeviceSDK
//
//  Created by willy.wu on 2022/7/25.
//

#import <MicroLifeDeviceSDK/MicroLifeDeviceSDK.h>

NS_ASSUME_NONNULL_BEGIN

@interface MicroLifeECGSettingValues : MicroLifeDataModel

/**
 SW_BT：
 Turn of all Bluetooth user interface like airplane mode. If the use set this bit by Bluetooth, device is effective after disconnection.
 
 User can turn on this function by device setting mode. (refer to user manual)
 */
@property (nonatomic, strong) NSNumber *SW_BT;

/**
 SW_BPplusECG：
 0: only measure blood pressure
 1: After blood pressure measurement, device will auto start ECG trigger by arrthymia.
*/
@property (nonatomic, strong) NSNumber *SW_BPplusECG;

/**
 SW_max3003_filter：
 0:turn off frontend filter
 1:turn on frontend filter
*/
@property (nonatomic, strong) NSNumber *SW_max3003_filter;

/**
 SW_over_memory：
 0: If the memory records are equal to 40, device will display “ful” and not stop measure until clear memory.
 1: If the memory is full, device will clear the oldest memory to store new data.
*/
@property (nonatomic, strong) NSNumber *SW_over_memory ;

/**
 SW_continued_ECG：
 0: The measure time of ECG is 30 or 60 seconds, and raw data will be stored to flash memory.
 1: The measure time of ECG is unlimited for test purpose. The raw data won’t be stored to flash memory.
*/
@property (nonatomic, strong) NSNumber *SW_continued_ECG;

/// MAM interval：15, 30, 60,120
@property (nonatomic, assign) MAMInterval MAMInterval;

/// Length (sample time)：0:N/A, 1:30 seconds, 2:60seconds
@property (nonatomic, assign) SsampleTime length;

@end

NS_ASSUME_NONNULL_END
